unit Custlib;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ToCtrl;

procedure DragAreaFont(Sender: Tobject);
procedure DragAreaEnd;
procedure DropDrag(Sender, Source: TObject; X, Y: Integer);
procedure DragMouseDown(Form: Tform; Sender: TObject; Button: TMouseButton;
                        Shift: TShiftState; X, Y: Integer);
procedure DragMouseMove(Form: Tform; Sender: TObject;
                        Shift: TShiftState; X, Y: Integer);

Var
  iX, iY, iLeft, iWidth, iHeight, iTop, iXoffset, iYoffset: Integer;
  sFieldVal :string;
  P: Tpoint;

Const
  bStartDrag:Boolean = false;

implementation

uses
 Drag4u1, Drag4U2, Drag4U3;
{------------------}
procedure DragAreaFont( Sender: Tobject);
begin
if Sender is TlistBox then
  begin
   DragArea.Font.Assign ((Sender as TListBox).Font);
   (Sender as TListBox).BeginDrag(False);
  end
else
  begin
   DragArea.Font.Assign ((Sender as TEdit).Font);
   (Sender as TEdit).BeginDrag(False);
  end;
end;
{------------------}
procedure DragAreaEnd;
begin
     bStartDrag:= false;
     DragArea.Visible:=False;
end;
{------------------}
procedure DropDrag(Sender, Source: TObject; X, Y: Integer);
var
   SourceItem:  String;
   SourceIndex: Integer;
   SenderIndex: Integer;
begin

   if not bStartDrag then exit;

   bStartDrag:=False;

  if Sender = Source then
   begin
     exit;
   end;
{}
  if Source is TListBox then
   begin
     SourceItem :=(Source as TListBox).Items[(Source as TListBox).ItemIndex] ;
     SourceIndex:=(Source as TListBox).ItemIndex;
   end
  else
    if Source is TEdit then
        SourceItem := (Source as TEdit).Text;
{}
  if Sender is TListBox then
   begin
     With (Sender as TListBox) do

     SenderIndex:= ItemAtPos(point(X,Y-6),true);

     if Source is TListBox then
      begin
        (Source as TListBox).Items.Delete (SourceIndex);

        if SenderIndex = -1 then{Add to end of ListBox}
          (Sender as TListBox).Items.Add ( SourceItem )
        else{Insert}
          (Sender as TListBox).Items.Insert ( SenderIndex, SourceItem );
        exit;
      end;

     if Source is TEdit then
      begin
        if SenderIndex = -1 then{Add to end of ListBox}
          (Sender as TListBox).Items.Add ( SourceItem )
        else{Insert}
          (Sender as TListBox).Items.Insert ( SenderIndex, SourceItem );
        exit;
      end;
   end;

  if Sender is TEdit then
   begin
      (Sender as TEdit).Text := SourceItem ;
      exit;
   end;
end;
{------------------}
procedure DragMouseDown(Form: Tform; Sender: TObject; Button: TMouseButton;
                        Shift: TShiftState; X, Y: Integer);
begin
  if Not ( (Sender is TListBox) or (Sender is TEdit)  ) then exit;

  if Sender is TListBox then
     Begin
       If (Sender as TListbox).Items.Count = 0 then exit;

       iLeft      := (Sender as TListBox).Left;
       iWidth     := (Sender as TListBox).Width -2;
       iHeight    := (Sender as TListBox).ItemHeight;
       iTop       := (Sender as TListBox).Top;
       sFieldVal  := (Sender as TListBox).Items [(Sender as TListBox).ItemIndex];
       DragAreaFont (Sender);
     end
  else
     if Sender is TEdit then
        Begin
         iLeft      := (Sender as TEdit).Left;
         iWidth     := (Sender as TEdit).Width;
         iHeight    := (Sender as TEdit).Height;
         iTop       := (Sender as TEdit).Top;
         sFieldVal  := (Sender as TEdit).Text;
         DragAreaFont (Sender);
        end
     else
        exit;

  P := Form.ClientToScreen(Point(X,Y));

  DragArea.Left               := iLeft;
  DragArea.Width              :=iWidth;
  DragArea.Height             :=iHeight;
  DragArea.MessageArea.Caption:=sFieldVal;

  iXOffset                    := X - iLeft;
  iYOffset                    := iTop - iHeight;

  bStartDrag:=true;
  iX:=P.X; iY:=P.Y;
end;
{------------------}
procedure DragMouseMove(Form: Tform; Sender: TObject;
                        Shift: TShiftState; X, Y: Integer);
begin
  If not bStartDrag then Exit;

  P:= Form.ClientToScreen(Point(X,Y));

  if DragArea.Visible=false then
       {Wait for mouse to move 5 Pixels - needed for TlistBox}
        if (Abs( P.X - iX) < 5) and (Abs( P.Y - iY) < 5 )
        then Exit;

  DragArea.Left := P.X - iXoffset;
  DragArea.Top  := iYoffset + P.Y;
  DragArea.Visible:=True;
  Application.processmessages;
end;
{------------------}

end.
